chiark / gitweb /
mdw.conf: Use `sudo' instead of `become'.
[profile] / setup
... / ...
CommitLineData
1#! /bin/bash
2
3set -e
4
5###--------------------------------------------------------------------------
6### Basic setup.
7
8umask 002
9
10sub=
11mkdir -p $HOME$sub
12
13: ${REPO=http://ftp.distorted.org.uk/pub/mdw/profile}
14
15export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17###--------------------------------------------------------------------------
18### Sort out command line.
19
20xstuff= false=
21while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30done
31
32###--------------------------------------------------------------------------
33### Environment autoconfiguration.
34
35## Find out where I am
36here=$(pwd)
37
38## Suss out how to print things
39out=$(echo -n "foo"; echo "bar")
40if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43else
44 echon="echo"
45 echoc='\c'
46fi
47
48## Find out how to fetch things over the net
49$echon "Finding URL fetcher:$echoc"
50if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60fi
61
62###--------------------------------------------------------------------------
63### Create the necessary directories.
64
65echo "Creating directories..."
66for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74done
75echo " all done."
76
77###--------------------------------------------------------------------------
78### Install some more complicated programs.
79
80echo "Installing packages..."
81systems="
82 mlib:crc-mktab
83 checkpath:tmpdir
84"
85[ "$xstuff" ] && systems="$systems
86 xtoys:xatom
87"
88for system in $systems; do
89 set -- $(echo $system | tr : ' ')
90 sys=$1 prog=$2
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
100 $echon " unpacking$echoc"
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
103 $echon " configuring$echoc"
104 cd $dir
105 mkdir build
106 cd build
107 ../configure --prefix=$HOME$sub >>buildlog 2>&1
108 $echon " building$echoc"
109 make >>buildlog 2>&1
110 $echon " installing$echoc"
111 make install >>buildlog 2>&1
112 echo " done."
113 )
114 fi
115done
116echo " all done."
117
118###--------------------------------------------------------------------------
119### Install global configuration.
120
121echo -n "Installing dotfile configuration:"
122if [ -f $HOME$sub/.mdw.conf ]; then
123 echo " already installed."
124else
125 cp mdw.conf $HOME$sub/.mdw.conf
126 echo " done."
127fi
128
129## Symlink the various dotfiles into place
130dotfiles="
131 bash_profile bash_logout bashrc inputrc bash_completion
132 emacs emacs-calc vm gnus.el ercrc.el
133 vimrc mg zile
134 ditz-config
135 mailrc signature
136 cgrc tigrc
137 gdbinit
138 guile
139 rcrc
140 toprc
141 mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
142 aspell.conf
143 lisp-init.lisp:.cmucl-init.lisp
144 lisp-init.lisp:.sbclrc
145 lisp-init.lisp:.clisprc.lisp
146 lisp-init.lisp:.eclrc
147 swank.lisp
148 dircolors colordiffrc screenrc cvsrc indent.pro"
149[ "$xstuff" ] && dotfiles="$dotfiles
150 xinitrc xsession Xdefaults vncrc vncsession
151 fonts.conf
152 stalonetrayrc
153 putty-defaults:.putty/sessions/Default%20Settings
154 mdw.session:.config/gnome-session/sessions/mdw.session
155 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
156 e-keybindings.cfg:.enlightenment/keybindings.cfg
157 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
158 e16-bindings:.e16/bindings.cfg"
159echo "Installing dotfiles..."
160for d in $dotfiles; do
161 target=.$d
162 case $d in
163 *:*) target=${d#*:} d=${d%%:*};;
164 esac
165 ft=$HOME$sub/$target
166 dir=${ft%/*}
167 mkdir -p $dir
168 ln -s $here/dot/$d $ft.new
169 mv $ft.new $ft
170 echo " $target"
171done
172echo " all done."
173
174## Substitute things which need substituting.
175dotfilessubst="
176 gitconfig
177 pulse-default.pa.in:.pulse/default.pa"
178echo "Installing dotfiles with substitutions..."
179for d in $dotfilessubst; do
180 case $d in
181 *:*) target=${d#*:} d=${d%%:*};;
182 *) target=.$d d=$d.in;;
183 esac
184 ft=$HOME$sub/$target
185 dir=${ft%/*}
186 mkdir -p $dir
187 sed "
1881i\
189### generated by $here/setup; do not edit!\
190
191/@home@/ s\a\a$HOME\ag
192/@releasekey@/ s\a\a$(bin/mdw-conf release-key 481334C2)\ag
193/@gitignore@/ s\a\a$(bin/mdw-conf gitignore $here/git/gitignore)\ag
194" dot/$d >$ft.new
195 mv $ft.new $ft
196 echo " $target"
197done
198echo " all done."
199
200## Symlink backgrounds.
201backgrounds="
202 jue-peek.jpg
203 medusa.jpg
204 bsg-supper.jpg
205 rayne.jpg
206 hypatia.jpg
207 noodly.jpg
208 lovelace.jpg"
209if [ "$xstuff" ]; then
210 echo "Installing backgrounds..."
211 for b in $backgrounds; do
212 for e in enlightenment e16; do
213 dir=$HOME$sub/.$e/backgrounds
214 t=$dir/$b
215 mkdir -p $dir
216 ln -s $here/bg/$b $t.new
217 mv $t.new $t
218 done
219 echo " $b"
220 done
221 echo " all done."
222fi
223
224###--------------------------------------------------------------------------
225### Install useful scripts included in this package.
226
227scripts="
228 mdw-editor
229 mdw-pager
230 mdw-conf
231 mdw-build
232 emacsclient-hack
233 movemail-hack
234 sendmail-hack
235 aspell-hack
236 emerge-hack
237 lesspipe.sh
238 start-ssh-agent
239 svnwrap
240 hyperspec"
241[ "$xstuff" ] && scripts="$scripts
242 xinitcmd
243 un-backslashify-selection
244 lock-screen
245 xshutdown"
246echo "Installing scripts..."
247mkdir -p $HOME$sub/bin
248for s in $scripts; do
249 ft=$HOME$sub/bin/$s
250 ln -s $here/bin/$s $ft.new
251 mv $ft.new $ft
252 echo " $s"
253done
254echo " all done."
255
256hacks="
257 ssh:ssh"
258echo "Installing hacks..."
259for h in $hacks; do
260 d=${h%%:*} h=${h#*:}
261 ft=$HOME$sub/bin/hacks/$d
262 mkdir -p $ft
263 ln -s $here/hacks/$h $ft/$h.new
264 mv $ft/$h.new $ft/$h
265 echo " $d:$h"
266done
267echo " all done."
268
269###--------------------------------------------------------------------------
270### Set up the Emacs config.
271
272$echon "Finding a suitable emacs:$echoc"
273emacs=no
274for i in emacs22 emacs23 emacs21 emacs; do
275 if type -p >/dev/null $i; then
276 emacs=$i
277 break
278 fi
279done
280if [ $emacs = no ]; then
281 echo " failed."
282 emacs=:
283else
284 echo " $emacs."
285fi
286
287echo "Installing Emacs packages..."
288emacspkg="
289 make-regexp
290 ew-hols
291 mdw-gnus-patch
292 git git-blame vc-git stgit
293 quilt"
294for elib in $emacspkg; do
295 $echon " $elib:$echoc"
296 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
297 (progn
298 (setq load-path (nconc load-path (list "~/lib/emacs")))
299 (kill-emacs (condition-case nil
300 (progn (load-library "'"$elib"'") 0)
301 (error 1))))'; then
302 echo " already installed."
303 else
304 if [ -f el/$elib.el ]; then
305 cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
306 else
307 $echon " downloading$echoc"
308 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
309 fi
310 $echon " compiling$echoc"
311 (cd $HOME$sub/lib/emacs;
312 $emacs >/dev/null 2>&1 --no-site-file --batch \
313 --eval '(byte-compile-file "'"$elib.el"'")')
314 echo " done."
315 fi
316done
317echo " all done."
318
319$echon "Setting up Emacs configuration:$echoc"
320$echon " linking$echoc"
321for f in dot-emacs.el Makefile; do
322 set -- $(echo $link | tr : ' ')
323 ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
324 mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
325done
326$echon " compiling$echoc"
327make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
328echo " done."
329
330###----- That's all, folks --------------------------------------------------